


#include "Camera/KOFDefaultCamera.h"

#include "DrawDebugHelpers.h"
#include "Camera/CameraComponent.h"

AKOFDefaultCamera::AKOFDefaultCamera()
{
	PrimaryActorTick.bCanEverTick = true;
	
	MinFOV = 80.0f;
	MaxFOV = 85.0f;
	GetCameraComponent()->SetFieldOfView(MinFOV);

	HeightOffset = 60.0f;
	ZAveragingFactor = 2.0f;
}

void AKOFDefaultCamera::Tick(float DeltaSeconds)
{
	Super::Tick(DeltaSeconds);

	check(P1);
	check(P2);

	FVector P1Loc = P1->GetActorLocation();
	FVector P2Loc = P2->GetActorLocation();
	FVector CameraLoc = GetActorLocation();

	FVector MidPoint = FVector(CameraLoc.X, (P1Loc.Y + P2Loc.Y) / 2.0f, ((P1Loc.Z + P2Loc.Z) / ZAveragingFactor) + HeightOffset);
	SetActorLocation(MidPoint);
	
	// set FOV
}
